"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeTraits = void 0;
var depth_dependencies_helper_1 = require("./depth-dependencies.helper");
var is_dependent_on_helper_1 = require("./is-dependent-on.helper");
function normalizeTraits(traits) {
    var treatedTraits = traits
        .concat(traits.flatMap(function (trait) { return (0, depth_dependencies_helper_1.depthDependencies)(trait); }))
        .filter(function (trait, index, self) { return self.indexOf(trait) === index; })
        .sort(function (a, b) {
        var _a, _b, _c, _d;
        if ((0, is_dependent_on_helper_1.isDependentOn)(a, b))
            return 1;
        if ((0, is_dependent_on_helper_1.isDependentOn)(b, a))
            return -1;
        return ((_b = (_a = a.dependsOn) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) - ((_d = (_c = b.dependsOn) === null || _c === void 0 ? void 0 : _c.length) !== null && _d !== void 0 ? _d : 0);
    });
    return treatedTraits;
}
exports.normalizeTraits = normalizeTraits;
